// ****************************************************************************************************
// 3rd Edition Dungeons and Dragon Treasure Generator
//    ( as illustrated in Table 7-4, pp. 170-171 )
//
// C Source File
// Created By: RageHeart
// ****************************************************************************************************

#include "trgen.h"                                        // Include TRGEN Header File
#include "kbd.h"

// ****************************************************************************************************
// Main Function
// ****************************************************************************************************
void _main(void)
{
unsigned short done=0;                                    // FALSE

randomize();
FontSetSys(F_4x6);                                        // Use Small Font
while (!done)
  {
  clrscr();
  get_cr(); 
  switch (cr)
	  {
	  case 1 ... 30:
	  	coins(cr,0);
	  	goods(cr,0);
	  	mitems(cr,0);
	  	cashout();
  	break;	
  	default:
    	printf("\n** Invalid Challenge Rating: %d **\n",cr); 
    	WAIT_KEYPRESS;   
    break;	
    }
  cr=pp=gp=sp=cp=gems=art=mi=mimi=memi=mami=0;            // Resets all values
  printf ("\n\nPress any key to roll again, or escape to quit\n\n");
  done = !((getchar()) % 13320);
  }
}

// ****************************************************************************************************
// Rolls Dice.
// ****************************************************************************************************
unsigned short roll_dice(unsigned short sides,unsigned short times)                                                
{
unsigned short sum=0,i;

for (i=0;i<times;i++) sum+=(random(sides)+1);
return sum;
}

// ****************************************************************************************************
// Gets the encounter Challenge Rating.
// ****************************************************************************************************
void get_cr(void)                                                
{
char buffer[3];

printf("   ~~~~~~~~~~~~~~~~~~~~~\n");
printf(" *                RageHeart                 *\n");
printf(" *         Treasure Generator       *\n");
printf(" *                                                  *\n");
printf(" *                   Email to:                *\n");
printf(" *         rageheart@att.net         *\n");
printf("   ~~~~~~~~~~~~~~~~~~~~~\n\n");
printf ("Enter Encounter's Challenge Rating: ");
cr=(unsigned short)strtol(gets(buffer),NULL,0); 
}

// ****************************************************************************************************
// Outputs the generated treasure.
// ****************************************************************************************************
void cashout(void)                                                 
{
clrscr();
printf("   ~~~~~~~~~~~~~~~~~~~~~\n");
printf(" *                RageHeart                 *\n");
printf(" *         Treasure Generator       *\n");
printf("   ~~~~~~~~~~~~~~~~~~~~~\n\n");
if (pp>0) printf("- Platnum Pieces: %lu\n",pp);
if (gp>0) printf("- Gold Pieces: %lu\n",gp);
if (sp>0) printf("- Silver Pieces: %lu\n",sp);
if (cp>0) printf("- Copper Pieces: %lu\n",cp);
gengems();
genart();
if (mi>0) printf("- Mundane Items: %hu\n",mi);
if (mimi>0) printf("- Minor Magic Items: %hu\n",mimi);
if (memi>0) printf("- Medium Magic Items: %hu\n",memi);
if (mami>0) printf("- Major Magic items: %hu\n",mami);
WAIT_KEYPRESS;            
}

// ****************************************************************************************************
// Generates and lists gem values.
// ****************************************************************************************************
void gengems(void)                                                
{
unsigned short i, roll, gemtype[6]={0};

if (gems>0) 
  {
  for (i=0;i<gems;i++)
    {
    roll=(random(100)+1);
    switch (roll)
  	  {
			case 1 ... 25:   gemtype[5]++; break;			// 10 gp
			case 26 ... 50:  gemtype[4]++; break;			// 50 gp
  	  case 51 ... 70:  gemtype[3]++; break;			// 100 gp
  	  case 71 ... 90:  gemtype[2]++; break;			// 500 gp
  	  case 91 ... 99:  gemtype[1]++; break;			// 1000 gp
			case 100:        gemtype[0]++; break;			// 5000 gp
      }
    }
  printf("- Gems: %hu\n",gems);
  if (gemtype[0]>0) printf("    %hu gems (5000 gp value)\n",gemtype[0]);
  if (gemtype[1]>0) printf("    %hu gems (1000 gp value)\n",gemtype[1]);
  if (gemtype[2]>0) printf("    %hu gems (500 gp value)\n",gemtype[2]);
  if (gemtype[3]>0) printf("    %hu gems (100 gp value)\n",gemtype[3]);
  if (gemtype[4]>0) printf("    %hu gems (50 gp value)\n",gemtype[4]);
  if (gemtype[5]>0) printf("    %hu gems (10 gp value)\n",gemtype[5]);
  }
}

// ****************************************************************************************************
// Generates and lists art values.
// ****************************************************************************************************
void genart(void)                                                
{
unsigned short i, roll, arttype[12]={0};

if (art>0) 
  {
  printf("\n\n                      << MORE >>");	
  WAIT_KEYPRESS;  
  clrscr();
  for (i=0;i<art;i++)
    {
    roll=(random(100)+1);
    switch (roll)
	    {
	    case 1 ... 10: 	arttype[11]++; break;      // 55 gp	      	
	    case 11 ... 25:	arttype[10]++; break;      // 105 gp	      	  
	    case 26 ... 40:	arttype[9]++;  break;      // 350 gp	      	
	    case 41 ... 50:	arttype[8]++;  break;      // 550 gp	      	
	    case 51 ... 60:	arttype[7]++;  break;      // 700 gp	      	  
	    case 61 ... 70:	arttype[6]++;  break;      // 1050 gp	      	
	    case 71 ... 80:	arttype[5]++;  break;      // 1400 gp	      	
	    case 81 ... 85:	arttype[4]++;  break;      // 1750 gp
	    case 86 ... 90:	arttype[3]++;  break;      // 2500 gp	      	
	    case 91 ... 95:	arttype[2]++;  break;      // 3500 gp	      	  
	    case 96 ... 99:	arttype[1]++;  break;      // 5000 gp	      	
	    case 100:	      arttype[0]++;  break;      // 7000 gp	      	  
      }
    }
  printf("- Art: %hu\n",art);
  if (arttype[0]>0)  printf("    %hu art (7000 gp value)\n",arttype[0]);
  if (arttype[1]>0)  printf("    %hu art (5000 gp value)\n",arttype[1]);
  if (arttype[2]>0)  printf("    %hu art (3500 gp value)\n",arttype[2]);
  if (arttype[3]>0)  printf("    %hu art (2500 gp value)\n",arttype[3]);
  if (arttype[4]>0)  printf("    %hu art (1750 gp value)\n",arttype[4]);
  if (arttype[5]>0)  printf("    %hu art (1400 gp value)\n",arttype[5]);
  if (arttype[6]>0)  printf("    %hu art (1050 gp value)\n",arttype[6]);
  if (arttype[7]>0)  printf("    %hu art (700 gp value)\n",arttype[7]);
  if (arttype[8]>0)  printf("    %hu art (550 gp value)\n",arttype[8]);
  if (arttype[9]>0)  printf("    %hu art (350 gp value)\n",arttype[9]);
  if (arttype[10]>0) printf("    %hu art (105 gp value)\n",arttype[10]);
  if (arttype[11]>0) printf("    %hu art (55 gp value)\n",arttype[11]);
  printf("\n\n                      << MORE >>");	
  WAIT_KEYPRESS;  
  clrscr();
  printf("   ~~~~~~~~~~~~~~~~~~~~~\n");
  printf(" *                RageHeart                 *\n");
  printf(" *         Treasure Generator       *\n");
  printf("   ~~~~~~~~~~~~~~~~~~~~~\n\n");
  }
}

// ****************************************************************************************************
// Generates coin totals.
// ****************************************************************************************************
void coins(unsigned short cr, unsigned short times)
{
unsigned short roll=(random(100)+1);

switch (cr)
	{
	case 1:
	  switch (roll)
	    {
	    case 96 ... 100:	pp+=(roll_dice(4,1))*10;			break;	
	    case 53 ... 95:		gp+=(roll_dice(8,2))*10;			break;	  
	    case 30 ... 52:		sp+=(roll_dice(8,1))*100;			break;	
      case 15 ... 29:		cp+=(roll_dice(6,1))*1000;		break;	
	    }  
		break;
	case 2:
	  switch (roll)
	    {
	    case 96 ... 100:	pp+=(roll_dice(8,2))*10;			break;	
	    case 44 ... 95:		gp+=(roll_dice(10,4))*10;			break;	  
	    case 24 ... 43:		sp+=(roll_dice(10,2))*100;		break;	
      case 14 ... 23:		cp+=(roll_dice(10,1))*1000;		break;	
	    }  
		break;
	case 3:
		switch (roll)
	    {
	    case 96 ... 100:	pp+=(roll_dice(10,1))*10;			break;	
	    case 42 ... 95:		gp+=(roll_dice(4,1))*100;			break;	  
	    case 22 ... 41:		sp+=(roll_dice(8,4))*100;			break;	
      case 12 ... 21:		cp+=(roll_dice(10,2))*1000;		break;	
	    }  
		break;
	case 4:
		switch (roll)
	    {
	    case 96 ... 100:	pp+=(roll_dice(8,1))*10;			break;	
	    case 42 ... 95:		gp+=(roll_dice(6,1))*100;			break;	  
	    case 22 ... 41:		sp+=(roll_dice(12,4))*1000;		break;	
      case 12 ... 21:		cp+=(roll_dice(10,3))*1000;		break;	
	    }  
		break;	
	case 5:
	  switch (roll)
	    {
	    case 96 ... 100:	pp+=(roll_dice(10,1))*10;			break;	
	    case 39 ... 95:		gp+=(roll_dice(8,1))*100;			break;	  
	    case 20 ... 38:		sp+=(roll_dice(6,1))*1000;		break;	
      case 11 ... 19:		cp+=(roll_dice(4,1))*10000;		break;	
	    }  
		break;
	case 6:
		switch (roll)
	    {
	    case 96 ... 100:	pp+=(roll_dice(12,1))*10;			break;	
	    case 38 ... 95:		gp+=(roll_dice(10,1))*100;		break;	  
	    case 19 ... 37:		sp+=(roll_dice(8,1))*1000;		break;	
      case 11 ... 18:		cp+=(roll_dice(6,1))*10000;		break;
      }  
		break;
	case 7:
		switch (roll)
	    {
	    case 94 ... 100:	pp+=(roll_dice(4,3))*10;			break;	
	    case 36 ... 93:		gp+=(roll_dice(6,2))*100;			break;	  
	    case 19 ... 35:		sp+=(roll_dice(12,1))*1000;		break;	
      case 12 ... 18:		cp+=(roll_dice(10,1))*10000;	break;
      }
    break;
	case 8:
		switch (roll)
	    {
	    case 88 ... 100:	pp+=(roll_dice(6,3))*10;			break;
	    case 30 ... 87:		gp+=(roll_dice(8,2))*100;			break;	  
	    case 16 ... 29:		sp+=(roll_dice(6,2))*1000;		break;	
      case 11 ... 15:		cp+=(roll_dice(12,1))*10000;	break;
      }  
  	break;
	case 9:
		switch (roll)
	    {
	    case 86 ... 100:	pp+=(roll_dice(12,2))*10;			break;
	    case 30 ... 85:		gp+=(roll_dice(4,5))*100;			break;	  
	    case 16 ... 29:		sp+=(roll_dice(8,2))*1000;		break;	
      case 11 ... 15:		cp+=(roll_dice(6,2))*10000;		break;
      }  
 		break;
	case 10:
		switch (roll)
	    {
	    case 80 ... 100:	pp+=(roll_dice(6,5))*10;			break;
	    case 25 ... 79:		gp+=(roll_dice(4,6))*100;			break;	  
	    case 11 ... 24:		sp+=(roll_dice(10,2))*1000;		break;	
      }
		break;
	case 11:
		switch (roll)
	    {
	    case 76 ... 100:	pp+=(roll_dice(10,4))*10;			break;
	    case 15 ... 75:		gp+=(roll_dice(8,4))*1000;		break;	  
	    case 10 ... 14:		sp+=(roll_dice(10,3))*1000;		break;	
      }
		break;
	case 12:
		switch (roll)
	    {
	    case 76 ... 100:	pp+=(roll_dice(4,1))*100;			break;
	    case 15 ... 75:		gp+=(roll_dice(4,1))*1000;		break;	  
	    case 10 ... 14:		sp+=(roll_dice(12,3))*1000;		break;	
      }
		break;
	case 13:
		switch (roll)
	    {
	    case 76 ... 100:	pp+=(roll_dice(10,1))*100;		break;
	    case 9 ... 75:		gp+=(roll_dice(4,1))*1000;		break;	  
      }
		break;
	case 14:
		switch (roll)
	    {
	    case 76 ... 100:	pp+=(roll_dice(12,1))*100;		break;
	    case 9 ... 75:		gp+=(roll_dice(6,1))*1000;		break;	  
      }
		break;	
	case 15:
		switch (roll)
	    {
	    case 75 ... 100:	pp+=(roll_dice(4,3))*100;			break;
	    case 4 ... 74:		gp+=(roll_dice(8,1))*1000;		break;	  
      }
		break;
	case 16:
		switch (roll)
	    {
	    case 75 ... 100:	pp+=(roll_dice(4,3))*100;			break;
	    case 4 ... 74:		gp+=(roll_dice(12,1))*1000;		break;	  
      }
		break;
	case 17:
		switch (roll)
	    {
	    case 69 ... 100:	pp+=(roll_dice(10,2))*100;		break;
	    case 4 ... 68:		gp+=(roll_dice(4,3))*1000;		break;	  
      }
		break;
	case 18:
		switch (roll)
	    {
	    case 66 ... 100:	pp+=(roll_dice(4,5))*100;			break;
	    case 3 ... 65:		gp+=(roll_dice(6,3))*1000;		break;	  
      }
		break;
	case 19:
		switch (roll)
	    {
	    case 66 ... 100:	pp+=(roll_dice(10,3))*100;		break;
	    case 3 ... 65:		gp+=(roll_dice(8,3))*1000;		break;	  
      }
		break;
	case 20 ... 30:     
		switch (roll)
	    {
	    case 66 ... 100:	pp+=(roll_dice(10,4))*100;		break;
	    case 3 ... 65:		gp+=(roll_dice(8,4))*1000;		break;	  
      }
		break;
	}
times++;
if (times<2 && cr<29 && roll>96) coins(cr+1, times);	
}

// ****************************************************************************************************
// Generates Gems and Art totals.
// ****************************************************************************************************
void goods(unsigned short cr, unsigned short times)
{
unsigned short roll=(random(100)+1);

switch (cr)
	{
	case 1:
		switch (roll)
	    {
	    case 96 ... 100:	art+=1;										break;
	    case 91 ... 95:		gems+=1;									break;	  
      } 
		break;
	case 2:
		switch (roll)
	    {
	    case 96 ... 100:	art+=(roll_dice(3,1));		break;
	    case 82 ... 95:		gems+=(roll_dice(3,1));		break;	  
      } 
		break;
	case 3:
		switch (roll)
	    {
	    case 96 ... 100:	art+=(roll_dice(3,1));		break;
	    case 78 ... 95:		gems+=(roll_dice(3,1));		break;	  
      }
		break;
	case 4:
		switch (roll)
	    {
	    case 96 ... 100:	art+=(roll_dice(3,1));		break;
	    case 71 ... 95:		gems+=(roll_dice(4,1));		break;	  
      }
		break;	
	case 5:
		switch (roll)
	    {
	    case 96 ... 100:	art+=(roll_dice(4,1));		break;
	    case 61 ... 95:		gems+=(roll_dice(4,1));		break;	  
      }
		break;
	case 6:
		switch (roll)
	    {
	    case 93 ... 100:	art+=(roll_dice(4,1));		break;
	    case 57 ... 92:		gems+=(roll_dice(4,1));		break;	  
      }
		break;
	case 7:
		switch (roll)
	    {
	    case 89 ... 100:	art+=(roll_dice(4,1));		break;
	    case 49 ... 88:		gems+=(roll_dice(4,1));		break;	  
      }
		break;
	case 8:
		switch (roll)
	    {
	    case 86 ... 100:	art+=(roll_dice(4,1));		break;
	    case 46 ... 85:		gems+=(roll_dice(6,1));		break;	  
      }
		break;
	case 9:
		switch (roll)
	    {
	    case 81 ... 100:	art+=(roll_dice(4,1));		break;
	    case 41 ... 80:		gems+=(roll_dice(8,1));		break;	  
      }
		break;
	case 10:
		switch (roll)
	    {
	    case 80 ... 100:	art+=(roll_dice(6,1));		break;
	    case 36 ... 79:		gems+=(roll_dice(8,1));		break;	  
      }
		break;
	case 11:
		switch (roll)
	    {
	    case 75 ... 100:	art+=(roll_dice(6,1));		break;
	    case 25 ... 74:		gems+=(roll_dice(10,1));	break;	  
      }
		break;
	case 12:
		switch (roll)
	    {
	    case 71 ... 100:	art+=(roll_dice(8,1));		break;
	    case 18 ... 70:		gems+=(roll_dice(10,1));	break;	  
      }
		break;
	case 13:
		switch (roll)
	    {
	    case 67 ... 100:	art+=(roll_dice(10,1));		break;
	    case 12 ... 66:		gems+=(roll_dice(12,1));	break;	  
      }
		break;
	case 14:
		switch (roll)
	    {
	    case 67 ... 100:	art+=(roll_dice(6,2));		break;
	    case 12 ... 66:		gems+=(roll_dice(8,2));		break;	  
      }
		break;	
	case 15:
		switch (roll)
	    {
	    case 66 ... 100:	art+=(roll_dice(8,2));		break;
	    case 10 ... 65:		gems+=(roll_dice(10,2));	break;	  
      }
		break;
	case 16:
		switch (roll)
	    {
	    case 65 ... 100:	art+=(roll_dice(10,2));		break;
	    case 8 ... 64:		gems+=(roll_dice(6,4));		break;	  
      }
		break;
	case 17:
		switch (roll)
	    {
	    case 64 ... 100:	art+=(roll_dice(8,3));		break;
	    case 5 ... 63:		gems+=(roll_dice(8,4));		break;	  
      }
		break;
	case 18:
		switch (roll)
	    {
	    case 55 ... 100:	art+=(roll_dice(10,3));		break;
	    case 5 ... 54:		gems+=(roll_dice(12,3));	break;	  
      }
		break;
	case 19:
		switch (roll)
	    {
	    case 51 ... 100:	art+=(roll_dice(6,6));		break;
	    case 4 ... 50:		gems+=(roll_dice(6,6));		break;	  
      }
		break;
	case 20 ... 30: 
		switch (roll)
	    {
	    case 39 ... 100:	art+=(roll_dice(6,7));		break;
	    case 3 ... 38:		gems+=(roll_dice(10,4));	break;	  
      }
		break;
	}
times++;	
if (times<2 && cr<29 && roll>96)  goods(cr+1, times);	
}

// ****************************************************************************************************
// Generates Mundane and Magical Item totals.
// ****************************************************************************************************
void mitems(unsigned short cr, unsigned short times)
{
unsigned short roll=(random(100)+1);

switch (cr)
	{
	case 1:
		switch (roll)
	    {
	    case 96 ... 100:	mimi+=1;								break;
	    case 70 ... 95:		mi+=1;									break;	  
      }
		break;
	case 2:
		switch (roll)
	    {
	    case 86 ... 100:	mimi+=1;								break;
	    case 50 ... 85:		mi+=1;									break;	  
      }
		break;
	case 3:
		switch (roll)
	    {
	    case 80 ... 100:	mimi+=1;								break;
	    case 50 ... 79:		mi+=(roll_dice(3,1));		break;	  
      }
		break;
	case 4:
		switch (roll)
	    {
	    case 63 ... 100:	mimi+=1;								break;
	    case 43 ... 62:		mi+=(roll_dice(4,1));		break;	  
      }
		break;	
	case 5:
		switch (roll)
	    {
	    case 68 ... 100:	mimi+=(roll_dice(3,1));	break;
	    case 58 ... 67:		mi+=(roll_dice(4,1));		break;	  
      }
		break;
	case 6:
		switch (roll)
	    {
	    case 100:					memi+=1;								break;
	    case 60 ... 99:		mimi+=(roll_dice(3,1));	break;
	    case 55 ... 59:		mi+=(roll_dice(4,1));		break;	  	  
      }
		break;
	case 7:
		switch (roll)
	    {
	    case 98 ... 100:	memi+=1;								break;
	    case 52 ... 97:		mimi+=(roll_dice(3,1));	break;
      }
     break;
	case 8:
		switch (roll)
	    {
	    case 97 ... 100:	memi+=1;								break;
	    case 49 ... 96:		mimi+=(roll_dice(4,1));	break;
      }
		break;
	case 9:
		switch (roll)
	    {
	    case 92 ... 100:	memi+=1;								break;
	    case 44 ... 91:		mimi+=(roll_dice(4,1));	break;
      }
		break;
	case 10:
		switch (roll)
	    {
	    case 100:					mami+=1;									break;
	    case 89 ... 99:		memi+=1;									break;
	    case 41 ... 88:		mimi+=(roll_dice(4,1));		break;	  	  
      }
		break;
	case 11:
		switch (roll)
	    {
	    case 99 ... 100:	mami+=1;									break;
	    case 85 ... 98:		memi+=1;									break;
	    case 32 ... 84:		mimi+=(roll_dice(4,1));		break;	  	  
      }
		break;
	case 12:
		switch (roll)
	    {
	    case 98 ... 100:	mami+=1;									break;
	    case 83 ... 97:		memi+=1;									break;
	    case 28 ... 82:		mimi+=(roll_dice(6,1));		break;	  	  
      }
		break;
	case 13:
		switch (roll)
	    {
	    case 96 ... 100:	mami+=1;									break;
	    case 74 ... 95:		memi+=1;									break;
	    case 20 ... 73:		mimi+=(roll_dice(6,1));		break;	  	  
      }
		break;
	case 14:
		switch (roll)
	    {
	    case 93 ... 100:	mami+=1;									break;
	    case 59 ... 92:		memi+=1;									break;
	    case 20 ... 58:		mimi+=(roll_dice(6,1));		break;	  	  
      }
		break;	
	case 15:
		switch (roll)
	    {
	    case 91 ... 100:	mami+=1;									break;
	    case 47 ... 90:		memi+=1;									break;
	    case 12 ... 46:		mimi+=(roll_dice(10,1));	break;	  	  
      }
		break;
	case 16:
		switch (roll)
	    {
	    case 91 ... 100:	mami+=1;									break;
	    case 47 ... 90:		memi+=(roll_dice(3,1));		break;
	    case 41 ... 46:		mimi+=(roll_dice(10,1));	break;	  	  
      }
		break;
	case 17:
		switch (roll)
	    {
	    case 84 ... 100:	mami+=1;									break;
	    case 34 ... 83:		memi+=(roll_dice(3,1));		break;
	    }
		break;
	case 18:
		switch (roll)
	    {
	    case 81 ... 100:	mami+=1;									break;
	    case 25 ... 80:		memi+=(roll_dice(4,1));		break;
	    }
		break;
	case 19:
	  switch (roll)
	    {
	    case 71 ... 100:	mami+=1;									break;
	    case 5 ... 70:		memi+=(roll_dice(4,1));		break;
	    }
	  break;
	case 20 ... 30: 
		switch (roll)
	    {
	    case 100:					mami+=(roll_dice(3,1));		break;
	    case 26 ... 99:		memi+=(roll_dice(4,1));		break;
	    }
		switch (cr%20)
			{
			case 1:						mami+=1; 									break;
			case 2:						mami+=2; 									break;
			case 3:						mami+=4; 									break;
			case 4:						mami+=6; 									break;
			case 5:						mami+=9; 									break;
			case 6:						mami+=12;									break;
			case 7:						mami+=17;									break;
			case 8:						mami+=23;									break;
			case 9:						mami+=31;									break;
			case 10:					mami+=42;									break;	
			}
		break;
	}
times++;
if (times<2 && cr<29 && roll>96)  mitems(cr+1, times);	
}
